diff -BbruN freeswan-1.91.orig/pluto/xmap.c freeswan-1.91/pluto/xmap.c
--- freeswan-1.91.orig/pluto/xmap.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/xmap.c	Tue Jul  3 03:00:39 2001
@@ -0,0 +1,401 @@
+#ifdef OPENSSL
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <string.h>
+#include <sys/stat.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <openssl/stack.h>
+#include <openssl/asn1.h>
+#include <openssl/safestack.h>
+#include <openssl/pem.h>
+#include <openssl/x509.h>
+#include <openssl/x509v3.h>
+
+#include "x_sobj.h"
+#include "xmap_file.h"
+#include "xmap_dir.h"
+#include "xmap_db.h"
+#include "xmap_ldap.h"
+#include "xmap.h"
+
+#include <freeswan.h> /* needed by constants.h */
+#include "constants.h"
+#include "defs.h"
+#include "log.h"
+
+static XMAP_METHOD_LIST *xmth = NULL;
+
+XMAP *XMAP_new(const char *spec);
+STACK_OF(X509_OBJECT) *
+XMAP_lookup( XMAP *xm, const int type, const char *index, void *p );
+void XMAP_free(XMAP *xm);
+void XMAP_dump(XMAP *xm);
+
+int
+XMAP_register(XMAP_METHOD *meth)
+{
+  XMAP_METHOD_LIST *p;
+  int found;
+
+  for(p=xmth,found=0; ((!found) && (p)); p=p->next)
+    if (strcasecmp(meth->prefix, p->meth->prefix) == 0) found=1;
+
+  if (found) {
+    return 0;
+  } else {
+    p = malloc(sizeof(XMAP_METHOD_LIST));
+    if (p) {
+      p->next = xmth;
+      p->meth = meth;
+      xmth = p;
+    } else
+      return 0;
+  }
+  return 1;
+}
+
+void
+XMAP_METHOD_LIST_free( void )
+{
+  XMAP_METHOD_LIST *p, *q;
+
+  for(p=xmth; p;) {
+    q = p->next;
+    free(p);
+    q = p;
+  }
+}
+
+int
+XMAP_unregister(const char *prefix)
+{
+  XMAP_METHOD_LIST *p, *q;
+  int found;
+
+  for(p = xmth, found = 0; ((!found) && (p)); )
+    if (strcasecmp(p->meth->prefix, prefix) == 0)
+      found = 1;
+    else
+      p=p->next;
+
+  if (!found)
+    return 0;
+  else {
+    if ( p == xmth ) {
+      xmth = xmth->next;
+      free(p);
+    } else {
+      for(q = xmth; q->next != p; q = q->next);
+      q->next = p->next;
+      free(p);
+    }
+  }
+  return 1;
+}
+
+XMAP *
+XMAP_new(const char *spec)
+{
+  XMAP *ret;
+  char *s;
+
+  if ((ret = malloc(sizeof(XMAP))) == NULL) goto end;
+  if ((ret->spec = strdup(spec)) == NULL) goto end;
+  ret->methp = NULL;
+
+  if ((s = strchr(spec, DICT_SEPARATOR)) == NULL) {
+    log("No type prefix");
+  } else {
+    int l = (int)(s - spec) + 1;
+    XMAP_METHOD_LIST *p;
+    int found;
+
+    for(p=xmth, found = 0; ((!found) && (p));) {
+      if (strncasecmp(p->meth->prefix, spec, l-1) == 0)
+	found = 1;
+      else
+	p = p->next;
+    }
+
+    if (found) {
+      ret->pmap = p->meth->new(&s[1]);
+      if (! ret->pmap) goto end;
+      ret->methp = p;
+    } else {
+      log("Unknown map type spec: %s", spec);
+      goto end;
+    }
+  }
+  return ret;
+ end:
+  if (ret->spec) free(ret->spec);
+  if (ret) free(ret);
+  return NULL;
+}
+
+static int
+check_methp(XMAP *xm)
+{
+  XMAP_METHOD_LIST *p;
+
+  for(p = xmth; p; p = p->next)
+    if (xm->methp == p) {
+      return 1;
+    }
+
+  return 0;
+}
+
+STACK_OF(X509_OBJECT) *
+XMAP_lookup( XMAP *xm, const int type, const char *index, void *p )
+{
+  if ((!xm) || (!check_methp(xm)) || (! xm->methp->meth->lookup) )
+  {
+    return NULL;
+  }
+  return xm->methp->meth->lookup(xm->pmap, type, index, p);
+}
+
+void
+XMAP_free(XMAP *xm)
+{
+  if (!xm) return;
+  if (!xm->pmap) return;
+  if (!check_methp(xm)) return;
+  if (xm->methp->meth->free) xm->methp->meth->free(xm->pmap);
+  if (xm->spec) free(xm->spec);
+  free(xm);
+}
+
+void
+XMAP_dump(XMAP *xm)
+{
+  if (! xm->pmap) return;
+  if (!check_methp(xm)) return;
+  if (! xm->methp->meth->dump) return;
+  xm->methp->meth->dump(xm->pmap);
+}
+
+int
+X509_subjAltName_check_dns(X509 *x, const char *dns)
+{
+  int i, loc, ret;
+  X509_EXTENSION *ext;
+  u_char *p;
+  STACK_OF(GENERAL_NAME) *nsk = NULL;
+  GENERAL_NAME *gn;
+
+  ret = 0;
+  if ((loc = X509_get_ext_by_NID(x, NID_subject_alt_name, -1)) >= 0) {
+    if ((ext = X509_get_ext(x, loc)) != NULL) {
+      p = ext->value->data;
+      d2i_GENERAL_NAMES(&nsk, &p, ext->value->length);
+      if (nsk) {
+	for(i=0; i < sk_GENERAL_NAME_num(nsk); i++) {
+	  gn = sk_GENERAL_NAME_value(nsk, i);
+	  
+	  if (gn->type == GEN_DNS) {
+	    if (strncasecmp(dns, gn->d.ia5->data, gn->d.ia5->length) == 0) {
+	      ret = 1;
+	      break;
+	    }
+	  }
+	}
+	sk_GENERAL_NAME_free(nsk);
+	nsk = NULL;
+      }
+    }
+  }
+  return ret;
+}
+
+int
+X509_subjAltName_check_ip(X509 *x, const struct in_addr ip)
+{
+  int i, loc, ret;
+  X509_EXTENSION *ext;
+  u_char *p;
+  STACK_OF(GENERAL_NAME) *nsk = NULL;
+  GENERAL_NAME *gn;
+
+  ret = 0;
+  if ((loc = X509_get_ext_by_NID(x, NID_subject_alt_name, -1)) >= 0) {
+	if ((ext = X509_get_ext(x, loc)) != NULL) {
+		p = ext->value->data;
+		d2i_GENERAL_NAMES(&nsk, &p, ext->value->length);
+		if (nsk) {
+			for(i=0; i < sk_GENERAL_NAME_num(nsk); i++) {
+				gn = sk_GENERAL_NAME_value(nsk, i);
+	  
+				if (gn->type == GEN_IPADD) {
+					if (memcmp(&ip.s_addr, gn->d.ip->data, gn->d.ip->length) == 0) {
+						ret = 1;
+						break;
+					}
+				}
+			}
+			sk_GENERAL_NAME_free(nsk);
+			nsk = NULL;
+		}
+ 	 }
+  }
+  return ret;
+}
+
+
+/* some cloning procedures. needed to unshare connection
+ * for road warrior support.
+ */
+
+STACK_OF(XMAP) 
+*clone_sk_XMAP ( STACK_OF(XMAP) *sk_xm )
+{
+	/* declare new stack */
+	STACK_OF(XMAP) *temp_sk_xm;
+	int i;
+
+	/* clone contents of stack. Memory pointers stay the same
+	 * so further cloning for each sub-structure is needed.
+	 *
+	 * typedef struct stack_st
+	 * {
+	 *  int num;
+	 *  char **data;
+	 *  int sorted;
+	 *  int num_alloc;
+	 *  int (*comp)();
+	 * } STACK;
+	 */
+
+	temp_sk_xm = sk_XMAP_new_null();
+	for (i=0; i<sk_XMAP_num(sk_xm); i++) {
+	  XMAP *xm = sk_XMAP_value(sk_xm, i);
+
+	  /* clone XMAP */
+	  xm = clone_XMAP(xm);
+
+	  sk_XMAP_push(temp_sk_xm, xm);
+	}
+
+	/* return the newly cloned STACK_OF(XMAP) */
+	return temp_sk_xm;     
+}
+
+XMAP 
+*clone_XMAP ( XMAP *xm )
+{
+	XMAP *temp_xm;
+	/* cloning of XMAP....... 
+	 * typedef struct _xmap_st {
+	 *   char *spec;
+	 *   void *pmap;
+	 *   XMAP_METHOD_LIST *methp;
+	 * } XMAP;
+	 */
+
+	temp_xm = malloc(sizeof(XMAP));
+
+	temp_xm->spec = clone_str(xm->spec, "cloning XMAP spec");
+	temp_xm->pmap = clone_XMAP_pmap(xm->pmap, xm->spec);
+
+	/* let's try without cloning the XMAP_METHOD_LIST, so that
+	 * check_methp will work.
+	 * temp_xm->methp = clone_XMAP_METHOD_LIST(xm->methp);
+	 */ 
+	temp_xm->methp = xm->methp;
+
+	return temp_xm;
+}
+
+XMAP_METHOD_LIST 
+*clone_XMAP_METHOD_LIST ( XMAP_METHOD_LIST *xm_l )
+{
+	XMAP_METHOD_LIST *temp_xm_l;
+
+	/*
+	 * typedef struct _xmap_method_list_st {
+	 *   XMAP_METHOD *meth;
+	 *   struct _xmap_method_list_st *next;
+	 * } XMAP_METHOD_LIST;
+	 *
+	 * Recursive cloning...
+	 */
+
+	temp_xm_l = malloc(sizeof(XMAP_METHOD_LIST));
+	if (xm_l->next) {
+		temp_xm_l->next = clone_XMAP_METHOD_LIST(xm_l->next);
+	} else {
+		temp_xm_l->next = NULL;
+	}
+
+	temp_xm_l->meth = clone_XMAP_METHOD(xm_l->meth);
+	return temp_xm_l;
+}
+
+
+XMAP_METHOD
+*clone_XMAP_METHOD ( XMAP_METHOD *xm_m )
+{
+	XMAP_METHOD *temp_xm_m;
+
+	/*
+	 * typedef struct _xmap_method_st {
+	 *   char *prefix;
+	 *     STACK_OF(X509_OBJECT) *(*lookup)( void *this, 
+	 *        const int type, const char *index, void *p );
+	 *   void (*dump)(void *pmap);
+	 *   void (*free)(void *pmap);
+	 *   void *(*new) (const char *spec);
+	 * } XMAP_METHOD;
+	 */
+
+
+	temp_xm_m = malloc(sizeof(XMAP_METHOD));
+
+	if (xm_m->prefix) {
+		temp_xm_m->prefix = clone_str(xm_m->prefix, 
+			"cloning XMAP_METHOD prefix");
+	}
+
+	/* don't clone the following */
+	temp_xm_m->lookup = xm_m->lookup;
+	temp_xm_m->dump = xm_m->dump;
+	temp_xm_m->free = xm_m->free;
+	temp_xm_m->new = xm_m->new;
+
+	return temp_xm_m;
+}
+
+void
+*clone_XMAP_pmap ( void *pmap, char *spec )
+{
+	void *t_pmap;
+	char *s;
+	int l, found;
+	XMAP_METHOD_LIST *p;
+
+	s = strchr(spec, DICT_SEPARATOR);
+	l = (int)(s - spec) + 1;
+
+	for(p=xmth, found = 0; ((!found) && (p));) {
+	  if (strncasecmp(p->meth->prefix, spec, l-1) == 0) {
+	    found = 1;
+	   } else {
+	    p = p->next;
+           }
+	}
+
+	if (found) {
+	  t_pmap = p->meth->new(&s[1]);
+	}
+
+	return t_pmap;
+}
+
+
+IMPLEMENT_STACK_OF(XMAP)
+#endif /* OPENSSL */
diff -BbruN freeswan-1.91.orig/pluto/xmap.h freeswan-1.91/pluto/xmap.h
--- freeswan-1.91.orig/pluto/xmap.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/xmap.h	Tue Jul  3 03:00:39 2001
@@ -0,0 +1,62 @@
+#ifndef XMAP_H
+#define XMAP_H
+
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <openssl/safestack.h>
+#include <openssl/x509.h>
+#include <openssl/x509_vfy.h>
+
+#include "x_sobj.h"
+
+typedef struct _xmap_method_st {
+  char *prefix;
+    STACK_OF(X509_OBJECT) *(*lookup)( void *this, const int type, const char *index, void *p );
+  void (*dump)(void *pmap);
+  void (*free)(void *pmap);
+  void *(*new) (const char *spec);
+} XMAP_METHOD;
+
+typedef struct _xmap_method_list_st {
+  XMAP_METHOD *meth;
+  struct _xmap_method_list_st *next;
+} XMAP_METHOD_LIST;
+
+typedef struct _xmap_st {
+  char *spec;
+  void *pmap;
+  XMAP_METHOD_LIST *methp;
+} XMAP;
+
+DECLARE_STACK_OF(XMAP)
+
+#ifndef DICT_SEPARATOR
+#define DICT_SEPARATOR ':'
+#endif
+
+#define XMAP_UNKNOWN_TYPE 0
+#define XMAP_FILE_TYPE    1
+#define XMAP_DIR_TYPE     2
+#define XMAP_DB_TYPE      3
+
+int XMAP_register(XMAP_METHOD *meth);
+void XMAP_METHOD_LIST_free( void );
+int XMAP_unregister(const char *prefix);
+
+int X509_subjAltName_check_dns(X509 *x, const char *dns);
+int X509_subjAltName_check_ip(X509 *x, const struct in_addr in);
+
+XMAP *XMAP_new(const char *spec);
+STACK_OF(X509_OBJECT) *XMAP_lookup( XMAP *xm, const int type, const char *index, void *p );
+void XMAP_free(XMAP *xm);
+void XMAP_dump(XMAP *xm);
+
+extern STACK_OF(XMAP) *clone_sk_XMAP ( STACK_OF(XMAP) *sk_xm );
+extern XMAP *clone_XMAP ( XMAP *xm );
+extern void *clone_XMAP_pmap ( void *pmap, char *spec );
+extern XMAP_METHOD_LIST *clone_XMAP_METHOD_LIST ( XMAP_METHOD_LIST *xm_l );
+extern XMAP_METHOD *clone_XMAP_METHOD ( XMAP_METHOD *xm_m );
+
+#endif /* XMAP_H */
diff -BbruN freeswan-1.91.orig/pluto/xmap_db.c freeswan-1.91/pluto/xmap_db.c
--- freeswan-1.91.orig/pluto/xmap_db.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/xmap_db.c	Tue Jul  3 03:00:39 2001
@@ -0,0 +1,574 @@
+#ifdef OPENSSL
+#if defined(HAVE_DB) || (HAVE_DB185)
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <string.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#include <errno.h>
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+
+#ifdef HAVE_DB185
+#include <db_185.h>
+#else
+#include <db.h>
+#endif
+
+#include <openssl/bio.h>
+#include <openssl/pem.h>
+#include <openssl/x509v3.h>
+
+#include "xmap_db.h"
+
+#include <freeswan.h> /* needed by constants.h */
+#include "constants.h"
+#include "defs.h"
+#include "log.h"
+
+static void XMAP_DB_dump(void *this);
+static void XMAP_DB_free(void *this);
+static void *XMAP_DB_new(const char *dbname);
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup( void *this, const int type, const char *index, void *p );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_subject( XMAP_DB *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_issuer( XMAP_DB *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_crl_by_issuer( XMAP_DB *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_uid( XMAP_DB *xm, const char *uid );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_dns( XMAP_DB *xm, const char *dns );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_ip( XMAP_DB *xm, const struct in_addr ip);
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_ca_certs( XMAP_DB *xm );
+
+#define TAGLEN 4
+
+static unsigned char tag_cert[] = { 0x00, 0x00, 0x00, 0x00 };
+static unsigned char tag_subj[] = { 0x00, 0x00, 0x00, 0x01 };
+static unsigned char tag_csub[] = { 0x00, 0x00, 0x00, 0x02 };
+static unsigned char tag_uid[] = { 0x00, 0x00, 0x00, 0x03 };
+static unsigned char tag_crl[] = { 0x00, 0x00, 0x00, 0x04 };
+static unsigned char tag_ca[] = { 0x00, 0x00, 0x00, 0x05 };
+static unsigned char tag_dns[] = { 0x00, 0x00, 0x00, 0x06 };
+static unsigned char tag_ip[] = { 0x00, 0x00, 0x00, 0x07 };
+
+#define DBZ(x) memset(&(x), 0, sizeof((x)))
+
+static XMAP_METHOD xmap_db_methods = {
+  "db",
+  XMAP_DB_lookup,
+  XMAP_DB_dump,
+  XMAP_DB_free,
+  XMAP_DB_new
+};
+
+void *
+XMAP_DB_new(const char *dbname)
+{
+  XMAP_DB *ret;
+
+  if ((ret = alloc_thing(XMAP_DB, "xmap_db")) == NULL) goto end;
+  if ((ret->dbname = clone_bytes(dbname, strlen(dbname)+1, "dbname")) == NULL)
+    goto end;
+  if ((ret->db = dbopen(dbname, O_RDONLY, 0, DB_HASH, NULL)) == NULL)
+    goto end;
+
+  ret->meth = &xmap_db_methods;
+
+  return (void *)ret;
+ end:
+  if (ret->db) ret->db->close(ret->db);
+  if (ret->dbname) pfree(ret->dbname);
+  if (ret) pfree(ret);
+  return NULL;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup( void *this, const int type, const char *index, void *p )
+{
+  XMAP_DB *xm = (XMAP_DB *)this;
+
+  switch(type) {
+  case X509_LU_X509:
+    if (strcasecmp(index, "subject") == 0)
+      return XMAP_DB_lookup_cert_by_subject( xm, (X509_NAME *)p);
+    if (strcasecmp(index, "issuer") == 0)
+      return XMAP_DB_lookup_cert_by_issuer( xm, (X509_NAME *)p);
+    else if (strcasecmp(index, "uid") == 0)
+      return XMAP_DB_lookup_cert_by_uid( xm, (char  *)p);
+    else if (strcasecmp(index, "dns") == 0)
+      return XMAP_DB_lookup_cert_by_dns( xm, (char  *)p);
+    else if (strcasecmp(index, "ip") == 0)
+      return XMAP_DB_lookup_cert_by_ip( xm, *((struct in_addr *)p));
+    else if (strcasecmp(index, "ca") == 0)
+      return XMAP_DB_lookup_ca_certs( xm );
+    else
+      return NULL;
+    break;
+  case X509_LU_CRL:
+    if (strcasecmp(index, "issuer") == 0)
+      return XMAP_DB_lookup_crl_by_issuer( xm, (X509_NAME *)p);
+    else
+      return NULL;
+    break;
+  default:
+    return NULL;
+  }
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_subject(XMAP_DB *xm, X509_NAME *name)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  dlen = i2d_X509_NAME(name, NULL);
+  if ((d = alloc_bytes(dlen + TAGLEN, "ASN.1 name")) == NULL) goto end;
+  dum = &d[TAGLEN];
+  memcpy(d, tag_subj, TAGLEN);
+  i2d_X509_NAME(name, &dum);
+  k.data = d;
+  k.size = dlen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[i*SHA_DIGEST_LENGTH+TAGLEN], SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+	  if (x)
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_issuer(XMAP_DB *xm, X509_NAME *name)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  dlen = i2d_X509_NAME(name, NULL);
+  if ((d = alloc_bytes(dlen + TAGLEN, "ASN.1 name")) == NULL) goto end;
+  dum = &d[TAGLEN];
+  memcpy(d, tag_subj, TAGLEN);
+  i2d_X509_NAME(name, &dum);
+  k.data = d;
+  k.size = dlen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[i*SHA_DIGEST_LENGTH+TAGLEN], SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+	  if (x)
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static int
+isCA( X509 *x )
+{
+  X509_EXTENSION *ext;
+  BASIC_CONSTRAINTS *p = NULL;
+  int loc;
+  
+  loc = X509_get_ext_by_NID(x, NID_basic_constraints, -1);
+  if (loc >= 0) {
+    ext = X509_get_ext(x, loc);
+    if (ext) {
+      p = X509V3_EXT_d2i(ext);
+      if (! p->ca) {
+	BASIC_CONSTRAINTS_free(p);
+	return 0;
+      } else {
+	BASIC_CONSTRAINTS_free(p);
+	return 1; /* This is a CA certificate */
+      }
+    } else
+      return 0;
+  } else
+    return 0;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_crl_by_issuer(XMAP_DB *xm, X509_NAME *name)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  dlen = i2d_X509_NAME(name, NULL);
+  if ((d = alloc_bytes(dlen + TAGLEN, "ASN.1 name")) == NULL) goto end;
+  dum = &d[TAGLEN];
+  memcpy(d, tag_csub, TAGLEN);
+  i2d_X509_NAME(name, &dum);
+  k.data = d;
+  k.size = dlen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_crl, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[i*SHA_DIGEST_LENGTH+TAGLEN], SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509_CRL *c;
+	dum = (unsigned char *)v2.data;
+	if ((c = d2i_X509_CRL(NULL, &dum, v2.size)) != NULL) {
+	  X509_OBJECT *xo = X509_OBJECT_new(X509_LU_CRL, c);
+
+	  if (xo)
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_CRL_free(c);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_ca_certs( XMAP_DB *xm )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  if ((d = alloc_bytes(TAGLEN, "CA tag")) == NULL) goto end;
+  memcpy(d, tag_ca, TAGLEN);
+  k.data = d;
+  k.size = TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[(i*SHA_DIGEST_LENGTH)+TAGLEN],
+	     SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if (((x = d2i_X509(NULL, &dum, v2.size)) != NULL) && (isCA(x))) {
+	  X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+
+	  if (xo) 
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_uid(XMAP_DB *xm, const char *uid)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, ulen, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  ulen = strlen(uid);
+  if ((d = alloc_bytes(ulen + TAGLEN, "uid tag")) == NULL) goto end;
+  memcpy(d, tag_uid, TAGLEN);
+  strncpy(&d[TAGLEN], uid, ulen);
+  k.data = d;
+  k.size = ulen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[(i*SHA_DIGEST_LENGTH)+TAGLEN],
+	     SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+
+	  if (xo) 
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_dns(XMAP_DB *xm, const char *dns)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, ulen, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  ulen = strlen(dns);
+  if ((d = alloc_bytes(ulen + TAGLEN, "dns tag")) == NULL) goto end;
+  memcpy(d, tag_dns, TAGLEN);
+  strncpy(&d[TAGLEN], dns, ulen);
+  k.data = d;
+  k.size = ulen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[(i*SHA_DIGEST_LENGTH)+TAGLEN],
+	     SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  if (X509_subjAltName_check_dns(x, dns)) {
+	    X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+	    
+	    if (xo) 
+	      sk_X509_OBJECT_push(sk, xo);
+	    else
+	      X509_free(x);
+	  } else 
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) free(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_ip(XMAP_DB *xm, const struct in_addr ip)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, ulen, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  ulen = sizeof(ip.s_addr);
+  if ((d = alloc_bytes(ulen + TAGLEN, "ip tag")) == NULL) goto end;
+  memcpy(d, tag_ip, TAGLEN);
+  memcpy(&d[TAGLEN], &ip.s_addr, ulen);
+  k.data = d;
+  k.size = ulen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[(i*SHA_DIGEST_LENGTH)+TAGLEN],
+	     SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+
+        DBG(DBG_PARSING | DBG_RAW,
+        DBG_log("** v2 length: %d", v2.size);
+        );
+        DBG(DBG_RAW,
+        DBG_dump("** v2: ", v2.data, v2.size);
+        );
+
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  if (X509_subjAltName_check_ip(x, ip)) {
+	    X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+	    
+	    if (xo) 
+	      sk_X509_OBJECT_push(sk, xo);
+	    else
+	      X509_free(x);
+	  }
+	} else
+	  X509_free(x);
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static void
+XMAP_DB_dump(void *this)
+{
+  XMAP_DB *xm = (XMAP_DB *)this;
+  DBG(DBG_PARSING,
+  DBG_log("XMAP_DB: %s", xm->dbname);
+  );
+}
+
+static void
+XMAP_DB_free(void *this)
+{
+  XMAP_DB *xm = (XMAP_DB *)this;
+
+  if (!xm) return;
+  if (xm->dbname) pfree(xm->dbname);
+  if (xm->db) xm->db->close(xm->db);
+  pfree(xm);
+}
+
+XMAP_METHOD *
+XMAP_METHOD_db( void )
+{
+  return (&xmap_db_methods);
+}
+#endif /* HAVE_DB */
+#endif /* OPENSSL */
diff -BbruN freeswan-1.91.orig/pluto/xmap_db.h freeswan-1.91/pluto/xmap_db.h
--- freeswan-1.91.orig/pluto/xmap_db.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/xmap_db.h	Tue Jul  3 03:00:39 2001
@@ -0,0 +1,27 @@
+#ifndef XMAP_DB_H
+#define XMAP_DB_H
+
+#if defined(HAVE_DB) || defined(HAVE_DB185)
+
+#include <openssl/safestack.h>
+#include <openssl/x509.h>
+
+#ifdef HAVE_DB185
+#include <db_185.h>
+#else
+#include <db.h>
+#endif
+
+#include "x_sobj.h"
+#include "xmap.h"
+
+typedef struct xmap_db_st {
+  char *dbname;
+  DB *db;
+  XMAP_METHOD *meth;
+} XMAP_DB;
+
+XMAP_METHOD *XMAP_METHOD_db( void );
+
+#endif /* HAVE_DB */
+#endif /* XMAP_DB_H */
